/*
<trigger>
	<usage>bsf verify_reviewers_have_approved.js</usage>
	<version>5.0</version>
	<description>
		RCR を承認状態にする前に、割り当てられたすべてのレビューアーが RCR を承認したかどうかを確認する。
	</description>
</trigger>
*/
importPackage(Packages.com.telelogic.cs.api);

var args = bsf.lookupBean('args');
var event = bsf.lookupBean('event');
var change = bsf.lookupBean('api');
var log = bsf.lookupBean('log');

//Attributes and attribute values the trigger will be looking at.
var approveValue = new java.lang.String("Approve");

var reviewer_1 = new java.lang.String("reviewer_1");
var reviewer_2 = new java.lang.String("reviewer_2");
var reviewer_3 = new java.lang.String("reviewer_3");
var reviewer_1_approval = new java.lang.String("reviewer_1_approval");
var reviewer_2_approval = new java.lang.String("reviewer_2_approval");
var reviewer_3_approval = new java.lang.String("reviewer_3_approval");
var numberOfAttributes = 6;

var attrsToFetch = java.lang.reflect.Array.newInstance(java.lang.String, numberOfAttributes);
attrsToFetch[0] = reviewer_1;
attrsToFetch[1] = reviewer_2;
attrsToFetch[2] = reviewer_3;
attrsToFetch[3] = reviewer_1_approval;
attrsToFetch[4] = reviewer_2_approval;
attrsToFetch[5] = reviewer_3_approval;

var options = OptionParser.parse(args);

var attrValueToMatch = args.shift();

var crAttributes = change.collectAttributes(event.triggerUser.token, event, attrsToFetch);

// gather only the attributes mentioned as args
var allOK = true;
var reviewerAttr = crAttributes.get(reviewer_1);
var attrValue = reviewerAttr.getStringValue();

if (attrValue != null && attrValue.length() > 0)
{
	//reviewer_1 is assigned
	log.debug("reviewer_1 is " + attrValue);
	var reviewerApprovalAttr = crAttributes.get(reviewer_1_approval);
	attrValue = reviewerApprovalAttr.getStringValue();
	
	if (!approveValue.equals(attrValue))
	{
		allOK = false;
	}
}

if (allOK)
{
	reviewerAttr = crAttributes.get(reviewer_2);
	attrValue = reviewerAttr.getStringValue();
	
	if (attrValue != null && attrValue.length() > 0)
	{
		//reviewer_2 is assigned
		log.debug("reviewer_2 is " + attrValue);
		var reviewerApprovalAttr = crAttributes.get(reviewer_2_approval);
		attrValue = reviewerApprovalAttr.getStringValue();
		
		if (!approveValue.equals(attrValue))
		{
			allOK = false;
		}
	}
}

if (allOK)
{
	reviewerAttr = crAttributes.get(reviewer_3);
	attrValue = reviewerAttr.getStringValue();

	if (attrValue != null && attrValue.length() > 0)
	{
		//reviewer_3 is assigned
		log.debug("reviewer_3 is " + attrValue);
		var reviewerApprovalAttr = crAttributes.get(reviewer_3_approval);
		attrValue = reviewerApprovalAttr.getStringValue();
		
		if (!approveValue.equals(attrValue))
		{
			allOK = false;
		}
	}
}

if (!allOK)
{
	event.fail(change.getMessage('errorTransitioningRCR'));
}
