[
	// "Default Lifecycle", "crstatus", "severity"
	// - Map status into phases
	// - Map severity to sort values
	// - Weight results cells
	// - Weighted cells use style ecp_mr_weighted
	// - Set title
	// - Set row and column name
	// - Result has 2 decimal digits
	{
		// Attribute information
		"lifecycle":"缺省生命周期",
		"row":"crstatus",
		"column":"severity",
		// Transformation
		"rowMapping":
			{
				"初始":["已提交", "重复已提交"],
				"分析":["分析中", "已分析", "重复分析中", "重复已分析"],
				"解决":["解决中", "已解决", "重复解决中", "重复已解决"],
				"评估":["评估中", "已评估", "重复评估中", "重复已评估"],
				"结束":["已做出结论", "重复已做出结论", "稍后发布", "重复稍后发布", "不可重现", "重复不可重现", "被拒绝", "重复被拒绝"],
				"其他":["分析失败", "重复分析失败", "重复", "评估失败", "重复评估失败", "待定", "重复待定", "解决失败", "重复解决失败"]
			},
		"columnMapping":
			{
				"未设置":["未设置"],
				"轻微":["轻微"],
				"中等":["中等"],
				"严重":["严重"],
				"障碍":["障碍"]
			},
		"weights":
			[
				// Not Set, Minor, Medium, Sever, Showstopper
				[1.0,       1.1,   1.2,    1.3,   1.4],    // Initial
				[2.0,       2.1,   2.2,    2.3,   2.4],    // Analysis
				[3.0,       3.1,   3.2,    3.3,   3.4],    // Resolution
				[4.0,       4.1,   4.2,    4.3,   4.4],    // Evaluation
				[5.0,       5.1,   5.2,    5.3,   5.4],    // Closed
				[6.0,       6.1,   6.2,    6.3,   6.4]     // Other
			],
		// Output
		"weightCellStyle":"ecp_mr_weighted",
		"mapErrorStyle":"ecp_mr_header_map_error",
		"title":"变更请求严重性（加权）",
		"rowTitle":"阶段",
		"columnTitle":"严重性",
		"digits":2
	},
	// As above for "Requirements Change Management Lifecycle"
	{
		// Attribute information
		"lifecycle":"需求变更管理生命周期",
		"row":"crstatus",
		"column":"severity",
		// Transformation
		"columnMapping":
			{
				"未设置":["未设置"],
				"轻微":["轻微"],
				"中等":["中等"],
				"严重":["严重"],
				"障碍":["障碍"]
			},
		"weights":
			[
				// Not Set, Minor, Medium, Sever, Showstopper
				[1.0,       1.1,   1.2,    1.3,   1.4],    // rcr_created
				[2.0,       2.1,   2.2,    2.3,   2.4],    // rcr_assigned
				[3.0,       3.1,   3.2,    3.3,   3.4],    // rcr_review
				[4.0,       4.1,   4.2,    4.3,   4.4],    // rcr_approved
				[5.0,       5.1,   5.2,    5.3,   5.4],    // rcr_applied
				[6.0,       6.1,   6.2,    6.3,   6.4]     // rcr_rejected
			],
		// Output
		"weightCellStyle":"ecp_mr_weighted",
		"mapErrorStyle":"ecp_mr_header_map_error",
		"title":"需求变更请求严重性（加权）",
		"rowTitle":"状态",
		"columnTitle":"严重性",
		"digits":2
	},
	// "Default Lifecycle", "crstatus", "priorty"
	// - Map status into phases
	// - Suppress title
	// - Result has 1 decimal digit
	{
		// Attribute information
		"lifecycle":"缺省生命周期",
		"row":"crstatus",
		"column":"priority",
		// Transformation
		"rowMapping":
			{
				"初始":["已提交", "重复已提交"],
				"分析":["分析中", "已分析", "重复分析中", "重复已分析"],
				"解决":["解决中", "已解决", "重复解决中", "重复已解决"],
				"评估":["评估中", "已评估", "重复评估中", "重复已评估"],
				"结束":["已做出结论", "重复已做出结论", "稍后发布", "重复稍后发布", "不可重现", "重复不可重现", "被拒绝", "重复被拒绝"],
				"其他":["分析失败", "重复分析失败", "重复", "评估失败", "重复评估失败", "待定", "重复待定", "解决失败", "重复解决失败"]
			},
		// Output
		"title":"",
		"digits":1
	},
	// "", "priority", "severity"
	// - Use column mapping to sort severity from showstopper to not set
	// - Suppress title
	{
		// Attribute information
		"lifecycle":"",
		"row":"priority",
		"column":"severity",
		// Transformation
		"columnMapping":
			{
				"障碍":["障碍"],
				"严重":["严重"],
				"中等":["中等"],
				"轻微":["轻微"],
				"未设置":["未设置"]
			},
		// Output
		"title":""
	},
	// "", "caused_during", "discovered_during"
	// - Map caused_during into phases
	// - Map discovered_during into phases
	{
		// Attribute information
		"lifecycle":"",
		"row":"caused_during",
		"column":"discovered_during",
		// Transformation
		"rowMapping":
			{
				"初始":["设想（初始阶段）", "需求收集（初始阶段）"],
				"分析":["需求分析（分析阶段）", "OO 分析和设计（分析阶段）"],
				"解决":["实现（解决阶段）", "构建（解决阶段）"],
				"评估":["集成测试（评估阶段）", "打包（评估阶段）", "性能测试（评估阶段）", "系统测试（评估阶段）", "用户验收测试（评估阶段）"],
				"结束":["产品（结束阶段）"]
			},
		"columnMapping":
			{
				"初始":["设想（初始阶段）", "需求收集（初始阶段）"],
				"分析":["需求分析（分析阶段）", "OO 分析和设计（分析阶段）"],
				"解决":["实现（解决阶段）", "构建（解决阶段）"],
				"评估":["集成测试（评估阶段）", "打包（评估阶段）", "性能测试（评估阶段）", "系统测试（评估阶段）", "用户验收测试（评估阶段）"],
				"结束":["产品（结束阶段）"]
			},
		// Output
		"mapErrorStyle":"ecp_mr_header_map_error",
		"digits":1
	}
]
