<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<!-- forms\admin_framework\admin_trends.jsp -->
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions"%>
<%@ taglib prefix="change" uri="http://www.telelogic.com/change"%>

<html>
<head>
<title></title>
<style type="text/css">
	<change:wsletExpander>
		<!-- WSLET CODE=PTInclude -->
		<!-- PARAM NAME=styles/default.css -->
		<!-- /WSLET -->
	</change:wsletExpander>

	.disabledLink
	{
		color: black;
	}
</style>
<script type="text/javascript" src="dwr/interface/ChartGeneratorAjax.js"></script>
<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/engine.js"></script>
<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dwr/util.js"></script>

<script type="text/javascript">
	var chartInterval = new Array(<change:chartKeys property="TRENDS_KEYS" />);

	var chartProcessorType = new Array(<change:chartKeys property="PROCESSOR_KEYS" />);

	var activeUsersTitle = "activeUserTrendTitleFromXtoY";
	var cmSessionsTitle = "cmSessionTrendTitleFromXtoY";
	
	function loadActiveUserChart(imageSource)
	{
		var img = document.getElementById("active_user_chart");
		loadChart(img, imageSource);
	}

	function loadCmSessionChart(imageSource)
	{
		var img = document.getElementById("cm_session_chart");
		loadChart(img, imageSource);
	}

	function loadChart(img, imageSource)
	{
		var imgDir = '<change:chartKeys property="CHART_IMAGES_LOCATION" />';
		img.src = imgDir + imageSource + "?" + new Date().getTime();
		
		if (imageSource.indexOf("active_user") >= 0)
		{
			document.getElementById("active_user_loadMsg").innerHTML = '';
		}
		else
		{
			document.getElementById("cm_session_loadMsg").innerHTML = '';
		}
	}

	function generateChartImage(linkId, chartType, chartTitleKey, chartInterval, chartProcessorType)
	{
		var img = document.getElementById(chartType);
		
		if (chartType == "active_user_chart") 
		{
			document.getElementById("active_user_loadMsg").innerHTML = '<change:resource key="loadingChart"/>';
		}
		else
		{
			document.getElementById("cm_session_loadMsg").innerHTML = '<change:resource key="loadingChart"/>';
		}
				
		/* Select the call back method.*/
		var chartToLoad = (chartType == "active_user_chart")
			? loadActiveUserChart
			: loadCmSessionChart;
				
		img.src = "<change:urlCreator webResource="PTIMAGES"/>spinningWait.gif";		
		
		ChartGeneratorAjax.generateChart("${user.token}", chartTitleKey, chartInterval, chartProcessorType, chartToLoad);
				
		removeCurrentHref(linkId,chartType);
		addPreviousHref(chartType, linkId);
	}
	
	function setAllHrefs()
	{
		var links = document.getElementsByTagName("a");

		for (var i = 0; i < links.length; i++)
		{
 			setHrefValue(links[i], links[i].id);
		}
	}

	/* 
	 * Set the href value to the given link object.
	 */	 
	function setHrefValue(link, index)
	{
		chartTitleKey = (link.type == "active_user_chart")
			? activeUsersTitle
			: cmSessionsTitle;
							
		chartProcessor = (link.type == "active_user_chart") 
			? chartProcessorType[0] 
			: chartProcessorType[1];

		hrefValue = "javascript:generateChartImage('"
					+ link.id + "','" + link.type + "','"
					+ chartTitleKey + "','" + chartInterval[index] + "','"
					+ chartProcessor + "')";

		link.setAttribute("href", hrefValue);
	}

	function addPreviousHref(linkType, currentLinkId)
	{
		var links = document.getElementsByTagName("a");

		for (var i = 0; i < links.length; i++)
		{
			/*IE returns "" and FireFox returns null if the given attribute is not present*/
			if (links[i].id != currentLinkId
				&& links[i].type == linkType
				&& (links[i].getAttribute("href") == "" || links[i].getAttribute("href") == null))
			{
				setHrefValue(links[i], links[i].id);

				if (document.all)//for IE
				{
					links[i].removeAttribute("className");
				}
				else
				{
					links[i].removeAttribute("class");
				}
				break;
			}
		}
	}

	function removeCurrentHref(linkId, linkType)
	{
		var links = document.getElementsByTagName("a");

		for (var i = 0; i < links.length; i++)
		{
			if (links[i].id == linkId && links[i].type == linkType)
			{
				links[i].removeAttribute("href");

				if (document.all)//for IE
				{
					links[i].setAttribute("className", "disabledLink");
				}
				else
				{
					links[i].setAttribute("class", "disabledLink");
				}
				break;
			}
		}
	}
	

	/* 
	 * Loads the defualt charts for Active User and CM/Session. 
	 * It also sets the hrefs for all the hyperlinks. 
	 */
	function onLoadMethod()
	{
		//set hrefs to all the hyper links
		setAllHrefs();
		
		generateChartImage("0", "active_user_chart", activeUsersTitle,
							chartInterval[0], chartProcessorType[0]);

		//make the second dwr call after 200 milliseconds
		setTimeout("generateChartImage('0', 'cm_session_chart', cmSessionsTitle, chartInterval[0], chartProcessorType[1])", 200);
	}	
</script>
</head>
<body onLoad="onLoadMethod();">
	<table width="100%" class="barHeading">
		<tr valign="top">
			<th><change:resource key="trendsTitle" /></th>
		</tr>
	</table>
	
	<%-- Set the var to loop over, delimited by ',' --%>
	<c:set var="chartResourceKeys">
		<change:chartKeys property="CHART_RESOURCE_KEYS" />
	</c:set>
	
	<table style="width:100%; height:100%;">
		<tr height="270" align="center">
			<td width="100%">
				<img id="active_user_chart" src="<change:urlCreator webResource="PTIMAGES"/>spinningWait.gif">
				<span id="active_user_loadMsg"></span>
			</td>
		</tr>
		<tr><%-- ACTIVE USERS OVER TIME --%>	
			<td id="user" style="text-align: center; padding: 7px">
				<%-- Similar to stringTokenizer --%>
				
				<c:forEach items="${fn:split(chartResourceKeys,',')}" var="token" varStatus="i">
					<c:if test="${i.count == 1}">						
						<a id="${i.count - 1}" type="active_user_chart" href=""><change:resource key="${token}"/></a>
					</c:if>
					
					<c:if test="${i.count > 1}">						
						| <a id="${i.count - 1}" type="active_user_chart" href=""><change:resource key="${token}"/></a>
					</c:if>					
				</c:forEach>

			</td>
		</tr>
		<tr height="270" align="center">
			<td width="100%">
				<img id="cm_session_chart" src="<change:urlCreator webResource="PTIMAGES"/>spinningWait.gif">								
				<span id="cm_session_loadMsg"><change:resource key="loadingChart"/></span>
			</td>
		</tr>
		<tr>
			<%-- IBM Rational Synergy SESSIONS OVER TIME --%>
			<td id="sessions" style="text-align: center;">

				<c:forEach items="${fn:split(chartResourceKeys,',')}" var="token" varStatus="i">
					<c:if test="${i.count == 1}">						
						<a id="${i.count - 1}" type="cm_session_chart" href=""><change:resource key="${token}"/></a>
					</c:if>
					
					<c:if test="${i.count > 1}">						
						| <a id="${i.count - 1}" type="cm_session_chart" href=""><change:resource key="${token}"/></a>
					</c:if>	
				</c:forEach>				

			</td>
		</tr>
	</table>
</body>
</html>
