<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<!-- forms\user_framework\acl_edit_folder_security.jsp -->
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>

<html>
<head>
	<title></title>
	
	<style type="text/css">

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=styles/default.css -->
	<!-- PARAM NAME=styles/acl_editor.css -->
	<!-- /WSLET -->
</change:wsletExpander>

.odd-row td
{
	background-color: #DDD;
}
	</style>
	
	<script type="text/javascript" src="<change:urlCreator webResource='JS'/>dojo/dojo/dojo.js" djConfig="parseOnLoad: true"></script>
	<script type="text/javascript">

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=EventUtils.js -->
	<!-- PARAM NAME=StyleUtils.js -->
	<!-- PARAM NAME=domUtilities.js -->
	<!-- PARAM NAME=MessageFormat.js -->
	<!-- /WSLET -->
</change:wsletExpander>

<change:wsletExpander>
	<!-- WSLET CODE=PTInclude -->
	<!-- PARAM NAME=TableSorter.js -->
	<!-- PARAM NAME=Zebra.js -->
	<!-- PARAM NAME=ScrapeText.js -->
	<!-- PARAM NAME=subhelp.js -->
	<!-- /WSLET -->
</change:wsletExpander>

/**
 * Functions to read the *visible* values of each logical column. 
 * Each array index is a function to read the column with the same index.
 * Used both in sorting and filtering, which both act on what the user sees
 * (not necessarily the underlying values of the controls.).
 */
var gColumnValueFunctions = [
	function(row)
	{
		return ScrapeText.fromTextNodes(row.cells[0]);
	},

	function(row)
	{
		return ScrapeText.fromInputs(row.cells[1]);
	},
	
	function(row)
	{
		return ScrapeText.fromInputs(row.cells[2]);
	}];
	
var gModified = false;

function hasModifications()
{
	return gModified;
}

function setModified()
{
	gModified = true;

	StyleUtils.addClass(
		document.getElementById('save-button'),
		'dirty');
}
	
function defaultRule_onChange(select)
{
	var option = select.options[select.selectedIndex];
	var defaultText = document.getElementById("all-folder-default-text");
	
	if (option.value == "grant")
	{
		defaultText.innerHTML = "<change:resource key="folderAclAllFolderDeny"/>";
	}
	else
	{
		defaultText.innerHTML = "<change:resource key="folderAclAllFolderGrant"/>";
	}
	
	setModified();
}

function filterKeyUp(evt)
{
	if (evt.keyCode == 13)
	{
		filter_onClick();
	}
}

function filter_onClick()
{
	var rows = document.getElementById('user-folders').rows;
	var filterText = document.getElementById('filter-string');
	var filterString = filterText.value.toLowerCase();

	for (var i = 0; i < rows.length; i++)
	{
		if (FolderAclFilter.filterMatchesRow(filterString, rows[i], gColumnValueFunctions))
		{
			rows[i].style.display = '';
		}
		else
		{
			rows[i].style.display = 'none';
		}
	}

	syncPageWithFilteredResults();
	document.getElementById("filter-all-button").disabled = false;
	filterText.select();
	filterText.focus();
}

function filterShowWithRules_onClick()
{
	document.getElementById('filter-string').value = '';

	var rows = document.getElementById('user-folders').rows;
	
	for (var i = 0; i < rows.length; i++)
	{
		if (FolderAclFilter.rowHasValue(rows[i], gColumnValueFunctions))
		{
			rows[i].style.display = '';
		}
		else
		{
			rows[i].style.display = 'none';
		}
	}
	
	syncPageWithFilteredResults();
	document.getElementById("filter-all-button").disabled = false;
}

function filterShowWithoutRules_onClick()
{
	document.getElementById('filter-string').value = '';
	
	var rows = document.getElementById('user-folders').rows;
	
	for (var i = 0; i < rows.length; i++)
	{
		if (FolderAclFilter.rowHasValue(rows[i], gColumnValueFunctions))
		{
			rows[i].style.display = 'none';
		}
		else
		{
			rows[i].style.display = '';
		}
	}
	
	syncPageWithFilteredResults();
	document.getElementById("filter-all-button").disabled = false;
}

function filterShowAll_onClick()
{
	document.getElementById('filter-string').value = '';

	var table = document.getElementById('acl-table');
	var rows = table.getElementsByTagName('tr');
	for (var i = 0; i < rows.length; i++)
	{
		var row = rows[i];
		row.style.display = '';
	}
	
	document.getElementById("filter-all-button").disabled = true;
	syncPageWithFilteredResults();
}

function syncPageWithFilteredResults()
{
	var foldersTbody = document.getElementById('user-folders');
	Zebra.stripeBody(foldersTbody, 'odd-row');
	FolderAclFilter.updateVisibleFolderCountMessage(foldersTbody);
}


/** Begin Methods involving ACL Folder Filtering  **/
function FolderAclFilter(){}

FolderAclFilter.ONE_FOLDER = '<change:resource key="folderAclShowingOneFolder"/>';
FolderAclFilter.X_OF_X_FOLDERS = '<change:resource key="folderAclShowingXofX"/>';
FolderAclFilter.X_FOLDERS = '<change:resource key="folderAclShowingXFolders"/>';

FolderAclFilter.updateVisibleFolderCountMessage = function(tbody)
{	
	//Start these at one as the default rule is always visible.
	var total = 1;
	var visible = 1;
	
	for (var i = 0; i < tbody.rows.length; i++)
	{
		var row = tbody.rows[i];

		if (row.style.display != 'none')
		{
			++visible;
		}

		++total;
	}
	
	FolderAclFilter._setVisibleFolderCountMessage(visible, total);
}

FolderAclFilter._setVisibleFolderCountMessage = function(current, total)
{
	var messageNode = document.getElementById('count-message');
	var child = getChildTextNodeByIndex(messageNode, 0);
	
	var allFoldersMessage = (total == 1)
		? FolderAclFilter.ONE_FOLDER
		: FolderAclFilter.X_FOLDERS;
		
	var message = (current == total)
		? new MessageFormat(allFoldersMessage).format([total])
		: new MessageFormat(FolderAclFilter.X_OF_X_FOLDERS).format([current, total]);

	messageNode.innerHTML = message;
}

FolderAclFilter.filterMatchesRow = function(filter, row, columnValueFunctions)
{
	var cells = row.cells;
	
	for (var i = 0; i < columnValueFunctions.length; i++)
	{
		var cellValue = columnValueFunctions[i](row).toLowerCase();

		if (null == cellValue) continue;

		if (-1 != cellValue.indexOf(filter))
		{
			return true;
		}
	}

	return false;
}

FolderAclFilter.rowHasValue = function(row, columnValueFunctions)
{
	var readersCell = columnValueFunctions[1](row);
	var readersWritersCell = columnValueFunctions[2](row);
		
	if (readersCell.length >0 || readersWritersCell.length > 0)
	{
		return true;
	}
	
	return false;
}

/** End Methods involving ACL Folder Filtering  **/

function save_onClick()
{
	var folderSecurity = new Object();
	
	var defaultSelect = document.getElementById('default-rule');
	
	if (defaultSelect.options[defaultSelect.selectedIndex].value == 'grant')
	{
		folderSecurity.defaultIsGranting = true;
	}
	else
	{
		folderSecurity.defaultIsGranting = false;
	}
	
	//Should only be one.
	var allFolderRows = document.getElementById('all-folder-default-table').rows;
	
	if (allFolderRows.length != 1)
	{
		alert("Coding error, the all-folder-default-table should only have a single row.");
		return;
	}
	
	folderSecurity.allFolderRule = new Object();
	folderSecurity.allFolderRule.folderName = "";
	folderSecurity.allFolderRule.readSecurityMembers = trim(gColumnValueFunctions[1](allFolderRows[0]));
	folderSecurity.allFolderRule.readWriteSecurityMembers = trim(gColumnValueFunctions[2](allFolderRows[0]));
	
	folderSecurity.folderRules = new Array();	
	
	var folderRows = document.getElementById('user-folders').rows;

	for (var i = 0; i < folderRows.length; i++)
	{
		folderSecurity.folderRules[i] = new Object();
		folderSecurity.folderRules[i].folderName = trim(gColumnValueFunctions[0](folderRows[i]));
		folderSecurity.folderRules[i].readSecurityMembers = trim(gColumnValueFunctions[1](folderRows[i]));
		folderSecurity.folderRules[i].readWriteSecurityMembers = trim(gColumnValueFunctions[2](folderRows[i]));
	}
	
	var folderSecurityJson = dojo.toJson(folderSecurity);
	
	document.manage_security_form.folderSecurityJson.value = folderSecurityJson;
	document.manage_security_form.submit();
}

function cancel_onClick()
{
	document.cancel_form.submit();
}

function trim(text) 
{
	text = text.replace( /^\s+/g, "" ); //remove all the leading whitespaces
  	return text.replace( /\s+$/g, "" ); //remove all the trailing whitespaces
}

function init_onLoad()
{
	EventUtils.addEvent(document.getElementById('filter-string'), 'keyup', filterKeyUp);
	
	new TableSorter(document.getElementById('user-folders'), gColumnValueFunctions, 'odd-row');	
}

EventUtils.addEvent(window, 'load', init_onLoad, false);

	</script>
	
</head>
<body>

<table class="barHeading" width="100%">
	<tr>
		<th id="header">
				<change:resource key="manageFolderSecurityLabel"/> &gt; 
			<span id="header">
				<c:set scope="page" var="datalistboxUserFriendlyName">
					<c:choose>
						<c:when test="${param.datalistbox == 'CRREPORTSHARED'}">
							<change:resource key="crSharedReports"/>
						</c:when>
						<c:when test="${param.datalistbox == 'CRREPORTPREDEFINED'}">
							<change:resource key="crSystemReports"/>
						</c:when>
						<c:when test="${param.datalistbox == 'CRQUERYREPORTSHARED'}">
							<change:resource key="crSharedFormats"/>
						</c:when>
						<c:when test="${param.datalistbox == 'CRQUERYREPORTPREDEFINED'}">
							<change:resource key="crSystemFormats"/>
						</c:when>
						<c:when test="${param.datalistbox == 'CRQUERYSHARED'}">
							<change:resource key="crSharedQueries"/>
						</c:when>
						<c:when test="${param.datalistbox == 'CRQUERYPREDEFINED'}">
							<change:resource key="crSystemQueries"/>
						</c:when>
						<c:when test="${param.datalistbox == 'TASKREPORTPREDEFINED'}">
							<change:resource key="taskSystemReports"/>
						</c:when>
						<c:when test="${param.datalistbox == 'TASKQUERYPREDEFINED'}">
							<change:resource key="taskSystemQueries"/>
						</c:when>
						<c:when test="${param.datalistbox == 'TASKQUERYREPORTPREDEFINED'}">
							<change:resource key="taskSystemFormats"/>
						</c:when>
						<c:when test="${param.datalistbox == 'TASKREPORTSHARED'}">
							<change:resource key="taskSharedReports"/>
						</c:when>
						<c:when test="${param.datalistbox == 'TASKQUERYSHARED'}">
							<change:resource key="taskSharedQueries"/>
						</c:when>
						<c:when test="${param.datalistbox == 'TASKQUERYREPORTSHARED'}">
							<change:resource key="taskSharedFormats"/>
						</c:when>
					</c:choose>
				</c:set>
				<c:out value="${datalistboxUserFriendlyName}"/>
			</span>
		</th>
		<td align="right" width="33%">
			<a href="javascript: openHelp('manage-folder-security');" title="<change:resource key='alt00043'/>">Help</a>			
		</td>
	</tr>
</table>

<c:set value="${fn:length(folderSecurity.securityForFolders) + 1}" var="numFolders"/>

<div id="search-box" style="text-align: right;">
	<input id="filter-string" type="text">
	
	<button type="button" id="filter-button" onclick="filter_onClick()" title="<change:resource key="folderAclFilterTitle"/>"><change:resource key="folderAclFilter"/></button>	
	<button type="button" id="filter-with-rules-button" onclick="filterShowWithRules_onClick()"><change:resource key="foldersAclWithRules"/></button>
	<button type="button" id="filter-no-rules-button" onclick="filterShowWithoutRules_onClick()"><change:resource key="foldersAclWithoutRules"/></button>
	<button type="button" id="filter-all-button" onclick="filterShowAll_onClick()" DISABLED="disabled"><change:resource key="folderAclShowAll"/></button>
	
	<div ID="count-message" STYLE="text-align: right; padding-top: .5em;">
		<c:choose>
			<c:when test="${numFolders == 1}">
				<change:resource key="folderAclShowingOneFolder"/>
			</c:when>
			<c:otherwise>
				<change:resource key="folderAclShowingXFolders">
					<change:param value="${numFolders}"/>
				</change:resource>
			</c:otherwise>
		</c:choose>
	</div> 
</div>

<span>
	<b>
		<change:resource key="folderAclDefaultRule"/>:&nbsp;
	</b>

	<select id="default-rule" onchange="defaultRule_onChange(this)">
		<option value="grant" <c:if test="${folderSecurity.isDefaultGranting}">selected</c:if>>
			<change:resource key="folderAclDefaultGrant"/>
		</option>
		<option value="deny" <c:if test="${!folderSecurity.isDefaultGranting}">selected</c:if>>
			<change:resource key="folderAclDefaultDeny"/>
		</option>
	</select>
</span>

<table class="acl-table" id="acl-table" cellspacing="0" width="100%">
<thead>
<tr>
	<th>
		<a href="#" class="sort-header" nowrap="nowrap">
			<change:resource key="folderAclFolderName"/>
		</a>
	</th>
	<th class="attribute-value" nowrap="nowrap">
		<a href="#" class="sort-header">
			<change:resource key="folderAclReadAccess"/>
		</a>
	</th>
	<th nowrap="nowrap">
		<a href="#" class="sort-header">
			<change:resource key="folderAclReadWriteAccess"/>
		</a>
	</th>
<tr>
<thead>

<tbody id="all-folder-default-table">
	<tr style="background-color: #fff9b0">
		<c:set value="${folderSecurity.securityForAllFolder}" var="allFolderRule"/>
		<td class="attribute-value" style="text-align:center;">
			<i id="all-folder-default-text">
			<c:choose>
				<c:when test="${folderSecurity.isDefaultGranting}">
					<change:resource key="folderAclAllFolderDeny"/>
				</c:when>
				<c:otherwise>
					<change:resource key="folderAclAllFolderGrant"/>
				</c:otherwise>
			</c:choose>
			</i>
		</td>
		<td>
			<input type="text" size="40" value="${allFolderRule.readSecurityMembersAsString}">
		</td>
		<td>
			<input type="text" size="40" value="${allFolderRule.readWriteSecurityMembersAsString}">
		</td>
	</tr>	
</tbody>

<tbody id="user-folders">
	<c:forEach items="${folderSecurity.securityForFolders}" var="folder" varStatus="status">
	<tr <c:if test="${((status.index + 1)% 2) == 0}">class="odd-row"</c:if> >
		<td class="attribute-value" style="text-align:center;">
			<c:out value="${folder.folderName}"/>
		</td>
		<td>
			<input type="text" size="40" value="${folder.readSecurityMembersAsString}">
		</td>
		<td>
			<input type="text" size="40" value="${folder.readWriteSecurityMembersAsString}">
		</td>
	</tr>
	</c:forEach>
</tbody>

</table>

<br />
<div style="text-align: center;">
	<button id="save-button" type="button" class="button" onclick="save_onClick()"><change:resource key="lbl00592"/></button>
	<button id="cancel-button" type="button" class="button" onclick="cancel_onClick()" style="margin-left: 1em;"><change:resource key="lbl00249"/></button>
</div>

<form name="manage_security_form" action="<change:urlCreator webResource='BASEURL'/>/manageFolderSecurity.do" class="hiddenForm" method="POST" target="_self">
	<input name="token" type="hidden" value="${user.token}">
	<input name="folderSecurityJson" type="hidden">
	<input name="datalistbox" type="hidden" value="${param.datalistbox}">
	<input name="datalistboxUserFriendlyName" type="hidden" value="${datalistboxUserFriendlyName}">
	<input name="methodToCall" type="hidden" value="saveChanges">
</form>

<form name="cancel_form" action="<change:urlCreator webResource='BASEURL'/>/formLoader.do" class="hiddenForm" method="POST" target="_self">
	<input name="token" type="hidden" value="${user.token}">
	<input name="formName" type="hidden" value="manageFolderSecurity">
	<input name="isForCRs" type="hidden" value="${param.isForCRs}">
	<input name="objectType" type="hidden" value="${param.objectType}">
</form>

</body>
</html>
